package org.kernel23.souriezmontpellier;

import java.util.ArrayList;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.drawable.Drawable;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;

public class HelloItemizedOverlay extends ItemizedOverlay<OverlayItem>
{
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	private Context mContext;

 public HelloItemizedOverlay(Drawable defaultMarker, Context context)
 {
	 super(boundCenterBottom(defaultMarker));
	 mContext = context;
 }

 public void addOverlay(OverlayItem overlay)
 {
	 mOverlays.add(overlay);
 	populate();
 }
 
 @Override
 protected OverlayItem createItem(int i)
 {
	 return mOverlays.get(i);
 }
 
 @Override
 public int size()
 {
	 return mOverlays.size();
 }
 
 @Override
 protected boolean onTap(int index)
 {
	 OverlayItem item = mOverlays.get(index);
	 AlertDialog.Builder dialog = new AlertDialog.Builder(mContext);
	 dialog.setTitle(item.getTitle());
	 dialog.setMessage(item.getSnippet());
	 dialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {

	     @Override
	     public void onClick(DialogInterface dialog, int which) {
	         dialog.dismiss();
	     }
	 });
	 dialog.show();
	 return true;
 }
}